

(* example 2. produces a proof-document from an "a
proof-script - annotated with docticcals and suitable comments 

The script must be run under bu's SList-theory. *)



open Rtf_punch;
open Rtf_docticals;

syn_db_update ("SList",
    create_ext_syntax SList.thy 
	[("op #" ,"['a, 'a list] => 'a list",Mixfix("_::_", [66, 65], 65)),
         ("op @","['a list, 'a list] => 'a list",Mixfix("_++_", [65, 66], 65))])

handle PUNCH s => writeln s ;


open_docfile "doc3";

goalw SList.thy [] 
"length(enum a b) = b-a";
by(CASE_IF "b <= a" 1);
by(SINCE_START);
by(asm_full_simp_tac (arith_ss addsimps [enum_le,length_Nil,less_imp_diff_is_0,less_Suc_eq_le]) 1);
by(SINCE_QED [Cmt"arithmetic, rewriting with assumption, enum_le."] 1);
by(CASE_ELSE 1);
byev[   SINCE_START,
	HINT "? k. b = Suc(a + k)" 
		(asm_full_simp_tac (HOL_ss addsimps 
			[not_le_eq_less,ex_add_eq_less RS sym]) ) 1,
	CMT [Cmt "from the assumption."] 1,
	etac exE 1,
	SINCE_EQ [Cmt"by quantifier elimination left:"] 1,
	hyp_subst_tac 1,
	UNFOLD "a+k" [add_commute] 1,
	SINCE_EQ [Cmt"by substitution:"] 1,
	asm_simp_tac (arith_ss addsimps 	
		[length_Cons,length_append,length_Nil,
		enum_app_single,length_enum]) 1,
	UNFOLD "k+a" [add_commute] 1,
	SINCE [Cmt"arithmetic, lists, enum_app_single, length_enum."] 1,
	simp_tac (arith_ss addsimps [less_add_Suc1,
		diff_add_inverse,Suc_diff_n]) 1,
	SINCE_QED [Cmt"arithmetic."] 1];
qed "length_enum_diff";
close_docfile();

