(* ******************************************************************** *)
(*  									*)
(* 	Project		: Ida - Isabelle's documentation assistant	*)
(*  	Author 		: B.Wolff					*)
(*  	Affiliation 	: University of Bremen, 			*)
(*			  Bremen Institute of Safe Systems (BISS)	*)
(*   	This file	: installation file for ida ((MS Word)-setting)	*)
(*  									*)
(*  	$Date: 1997/09/13 13:18:14 $					*)
(*      $Revision: 1.15 $						*)
(*  									*)
(*  ******************************************************************* *)

(* The installation requires an Isabelle/HOL-image, where the Syntax-
Module "Syn" has been updated with the Files in src. 
Based on Bremens HOL (Isabelle94-7 with the modified syntaxmodule). 							*)

(* generic paraphrasing machinery ... *)
   use ("num_mgr.sml");      (* management of chapter-refs and sub-proof-refs *)
   use ("ref_mgr.sml");      (* symbolic-refs management *)
   use ("doc_punch.sml");    (* documentation puncher *)
   use ("rtf_instance.sml"); (* instantiation of the doc_puncher for RTF *)
   use ("sgml_instance.sml"); (* instantiation of the doc_puncher for RTF *)

   (* ... more instances to come (LaTeX,... )     *)


(* generic paraphrasing machinery ...*)

   use ("induct.sml");       (* induction tractical *)
   use ("docticals.sml");    (* the doc-dumper *)

   structure RTF_docticals = Docticals (RTF);


(* optional checking ...*)
if CHECK then
   ( cd "examples";
     use ("ex1.sml");
     use ("ex2.sml");
     use ("ex3.sml");
     cd "..")
else ();




