open BM;


(*** foldr_ac ***)

goal thy "foldr_ac f e [] = [e]";
by (simp_tac(slist_ss addsimps [foldr_ac_def]) 1);
qed "foldr_ac_Nil";


goal thy "foldr_ac f e (a#S) = ?X";
br trans 1;
by (simp_tac(slist_ss addsimps [foldr_ac_def]) 1);
by (fold_tac [foldr_ac_def]);
br refl 1;
qed "foldr_ac_Cons";


goal thy "foldr_ac f e ([a,b,c,d]) = ?X";
by (simp_tac(slist_ss addsimps [foldr_ac_Nil, foldr_ac_Cons]) 1);


(*** map promotion

goal thy "map f (foldl (op @) [] xs) = foldl (op @) [] (map (map f) xs)";

by(slist_ind_tac "xs" 1);
by (simp_tac slist_ss 1);
by(asm_simp_tac(slist_ss addsimps []) 1);
by(GEN_ALL "x" 1);

***)

(*** reduce promotion

goal thy "foldl f e (foldl (op @) [] xs) = foldl f e (map (foldl f e) xs)";
by(GEN_ALL "e" 1);
by(slist_ind_tac "xs" 1);
by (simp_tac slist_ss 1);
by (asm_simp_tac slist_ss 1);

***)

(*** foldl_ac ***)

goal thy "foldl_ac f a [] = [a]";
by (simp_tac(slist_ss addsimps [foldl_ac_def]) 1);
qed "foldl_ac_Nil";

goal thy "foldl_ac f a (x#xs) = [a] @ (foldl_ac f (f a x) xs)";
by(asm_simp_tac(slist_ss addsimps [foldl_ac_def]) 1);
qed "foldl_ac_Cons";


(*** foldl_ac_map ***)

goal thy "foldl_ac f e (map g S) = foldl_ac (%x y. f x (g y)) e S";
by(GEN_ALL "e" 1);
by(slist_ind_tac "S" 1);
by(ALLGOALS(asm_simp_tac (slist_ss addsimps [foldl_ac_Nil,foldl_ac_Cons])));
qed "foldl_ac_map";



(*** spez. map_foldl_ac ***)

goal thy "map (op @ [x]) (foldl_ac (%x y. x @ single y) e xs) = \
       \   foldl_ac (%x y. x @ single y) ((single x)@e) xs";
by(GEN_ALL "e" 1);
by(slist_ind_tac "xs" 1);
by(asm_simp_tac(slist_ss addsimps [foldl_ac_Nil,single_def]) 1);
by(asm_full_simp_tac(slist_ss addsimps [foldl_ac_Cons,single_def]) 1);
qed "map_foldl_ac";






(*** inits ***)

goal thy "inits [] = [[]]";
by (simp_tac(slist_ss addsimps [inits_def, foldl_ac_def])1);
qed "inits_Nil";
goal thy "inits (x#xs) = [[]] @ (map (op @ [x]) (inits xs))";
by(asm_simp_tac(slist_ss addsimps [inits_def,foldl_ac_Cons,foldl_ac_map,map_foldl_ac])1);
qed "inits_Cons";



(*** Accumulation lemma ***)

goal thy "foldl_ac f e xs = map (foldl f e) (inits xs)";
by(GEN_ALL "e" 1);
by(slist_ind_tac "xs" 1);
by(asm_simp_tac(slist_ss addsimps [foldl_ac_Nil,inits_Nil]) 1);
by(asm_simp_tac(slist_ss addsimps [foldl_ac_Cons,single_def,inits_Cons,foldl_ac_map,map_compose RS sym, o_def]) 1);
qed "accu_lemma";


(*** All applied to ***)

goal thy "allappl [] a = []";
by (simp_tac(slist_ss addsimps [allappl_def]) 1);
qed "allappl_Nil";

goal thy "allappl (f#xs) a = f a # allappl xs a";
by (simp_tac(slist_ss addsimps [allappl_def]) 1);
qed "allappl_Cons";

val [pr1, pr2, pr3] = goal thy "[|! a. f a e = a; ! a. f e a = a; ! a b c. f a (f b c) = f (f a b) c |] ==> foldr f e xs = foldl f e xs";
by (slist_ind_tac "xs" 1);
by(ALLGOALS(asm_simp_tac(slist_ss addsimps [pr1, pr2,pr3]))); 
by (res_inst_tac [("f1","f")] (foldl_neutr_distr RS sym)1);
br pr1 1;
br pr2 1;
br pr3 1;
qed "foldr_vs_foldl";


