open CspTransfo1;

goal CspTransfo1.thy "Foldr f (s@t) b = Foldr f s (Foldr f t b)";
by(list.induct_tac "s" 1);
by(ALLGOALS(asm_simp_tac(list_ss addsimps [Foldr_Nil,Foldr_Cons])));
val Foldr_append = result();

goalw CspTransfo1.thy [LPrefix_def]"[] @-> P = P";
by(simp_tac(HOL_ss addsimps [Foldr_Nil])1);
val LPref_Nil = result();

goalw CspTransfo1.thy [LPrefix_def]"(a#s) @-> P = a ->(s @-> P)";
by(simp_tac(HOL_ss addsimps [Foldr_Cons])1);
val LPref_Cons = result();

goalw CspTransfo1.thy [LPrefix_def]"[a] @-> P = (a -> P)";
by(simp_tac(HOL_ss addsimps [Foldr_Cons,Foldr_Nil])1);
val LPref_elem = result();

goalw CspTransfo1.thy [LPrefix_def]"(s@t) @-> P = s @->(t @-> P)";
by(simp_tac(HOL_ss addsimps [Foldr_append])1);
val LPref_append = result();

goalw CspTransfo1.thy [LPrefix_def]"([] @-> P)= P";
by(simp_tac(HOL_ss addsimps [Foldr_Nil])1);
val Lpref_Nil = result();

goalw CspTransfo1.thy [LPrefix_def]"((a#l) @-> P)= (a -> (l @-> P))";
by(simp_tac(HOL_ss addsimps [Foldr_Cons])1);
val Lpref_Cons = result();

goal CspTransfo1.thy "((a#l) @-> P)= ([a] @-> (l @-> P))";
by(simp_tac(HOL_ss addsimps [Lpref_Cons,LPref_elem,Lpref_Nil])1);
val Lpref_Cons1 = result();

goal CspTransfo1.thy
 "((a#l) @-> P) |]A[| SKIP = (if a:A then STOP else a -> ((l@->P)|]A[|SKIP))";
by(CASE_DIST "a:A" 1);
by(ALLGOALS(asm_simp_tac(list_ss addsimps [Lpref_Cons,prefix_Par_Int_skip2,prefix_Par_Int_skip1])));
val Lpref_Par_Int_skip = result();


goal CspTransfo1.thy
 "((a#l) @-> P) |]A[| SKIP =(if a:A then STOP else [a] @-> ((l@->P)|]A[|SKIP))";
by(simp_tac(list_ss addsimps [Lpref_Par_Int_skip,LPref_elem])1);
val Lpref_Par_Int_skip1 = result();


goal CspTransfo1.thy
 "((a#l) @-> P) |]A[| SKIP = (if a:A then STOP else a -> ((l@->P)|]A[|SKIP))";
by(CASE_DIST "a:A" 1);
by(ALLGOALS(asm_simp_tac(list_ss addsimps [Lpref_Cons,prefix_Par_Int_skip2,prefix_Par_Int_skip1])));
val Lpref_Par_Int_skip = result();

goal CspTransfo1.thy "s|`A=[] --> ((s@->P)\\A) = (s@->(P\\A))";
by(list.induct_tac "s" 1);
by(ALLGOALS(rtac impI));
by(ALLGOALS(asm_full_simp_tac(list_ss addsimps [Lpref_Cons,Lpref_Nil,hide_prefix_distr1,hide_prefix_distr2,restr_Cons_Nil_spec])));
val Lpref_hide1 = result() RS mp;


val prem = goal CspTransfo1.thy "cont f ==> cont (%x. l @-> f x)";
by(cut_facts_tac prem 1);
by(list.induct_tac "l" 1);
by(ALLGOALS(asm_simp_tac(list_ss addsimps [Cont_Prefix.prefix_cont,Lpref_Cons,Lpref_Nil])));
val Lpref_cont = result();



val prem = goal CspTransfo1.thy 
"[|P << (P'\\B); A Int B = {}; (Q |]B[|SKIP)= Q|] ==>\
\    (P |]A[| Q) << ((P'|]A[| Q)\\B)";
by(cut_facts_tac prem 1);
by(res_inst_tac [("P2.0","(P'\\B) |]A[| Q")] ref_ord_trans 1);
by(rtac mono_PaI_ref_L 1);
by(FOLD "Q" [hide_set_empty] 2);
by(UNFOLD "?X" [R7] 2);
by(ALLGOALS(asm_simp_tac(set_ss addsimps
   [Int_commute,Inter_def RS meta_sym,Inter_skip1,
    hide_set_empty,ref_ord_refl])));
val R4 = result();


val prem = goalw CspTransfo1.thy [Inter_def]
"[|(P|]B[|SKIP)=P; (Q|]A[|SKIP)=Q|] ==>\
\            ((P\\A) ||| (Q\\B)) = ((P||| Q)\\(A Un B))";
by(cut_facts_tac prem 1);
by(asm_simp_tac(set_ss addsimps [R7])1);
val R5b=result();

val prem = goal CspTransfo1.thy 
"[|P << (P'\\A);Q << (Q'\\B); (P'|]B[|SKIP)=P'; (Q'|]A[|SKIP)=Q'|] ==>\
\    (P ||| Q) << ((P'||| Q')\\(A Un B))";
by(cut_facts_tac prem 1);
by(res_inst_tac [("P2.0","(P'\\A) ||| (Q'\\B)")] ref_ord_trans 1);
by(rtac mono_Inter_ref 1);
by(ALLGOALS(asm_simp_tac(set_ss addsimps [R5b,ref_ord_refl])));
val R5=result();

val prem = goal CspTransfo1.thy "P<<Q ==> (s@->P)<<(s@->Q)";
by(cut_facts_tac prem 1);
by(list.induct_tac "s" 1);
by(ALLGOALS(asm_simp_tac(list_ss addsimps [Lpref_Nil,Lpref_Cons,mono_prefix_ref])));
qed "mono_Lpref_ref";

goal CspTransfo1.thy
 "s |`A  =[] & a:A --> ((s@->P)|]A[|(a->Q))=s@->(P|]A[|(a->Q))";
by(list.induct_tac "s" 1);
by(ALLGOALS(rtac impI));
by(CASE_DIST "aa:A" 2);
by(ALLGOALS(rotate_tac 2));
by(ALLGOALS(asm_full_simp_tac(list_ss addsimps [Lpref_Nil,Lpref_Cons,restrict_Nil,restrict_Cons])));
by(rotate_tac 2 1);
by(asm_full_simp_tac(list_ss addsimps [prefix_Par_Int4])1);
val Lpref_Par_Int4 = (conjI RS(result() RS mp));


val prem = goal CspTransfo1.thy
 "[|s |`A  =[] ; a:A|] ==> ((a->Q)|]A[|(s@->P))=s@->((a->Q)|]A[|P)";
by(cut_facts_tac prem 1);
by(UNFOLD "?X" [Par_Int_commute] 1);
by(UNFOLD "(a -> Q)|]A[|(s @-> P)" [Par_Int_commute] 1);
by(rtac Lpref_Par_Int4 1);
by(ALLGOALS(atac));
val Lpref_Par_Int4_sym = result();


val prem = goal CspTransfo1.thy "cont f ==> cont(%P.s @->(f P))";
by(cut_facts_tac prem 1);
by(list.induct_tac "s" 1);
by(ALLGOALS(asm_simp_tac(merge_ss(list_ss,cont_ss) addsimps [Lpref_Nil,Lpref_Cons])));
val cont_Lpref = result();


val prem = goal CspTransfo1.thy 
"[|s |`{m,a} = [];t |`{m,a} = [] |] ==>\
\(/ X. s @-> (t @-> X)) <<\
\ (((/ X. s @-> (m ->(a -> X))) |]{m,a}[| (/ X. m ->(t @->(a -> X))))\\{m,a})";
by(rtac mu_ind2 1);
by(ALLGOALS(asm_simp_tac(list_ss addsimps prem@[cont_Lpref,Cont_Prefix.prefix_cont,cont_id,Lpref_Par_Int4,prefix_par_Int2,Lpref_Par_Int4_sym,Lpref_hide1,hide_prefix_distr1,mono_Lpref_ref])));
val R1 = result();


val prem = goal CspTransfo1.thy 
"[|m~=e; a~=e; m~=f; a~=f|] ==>\
\(/ X. e -> (f -> X)) <<\
\ (((/ X. e -> (m ->(a -> X))) |]{m,a}[| (/ X. m ->(f ->(a -> X))))\\{m,a})";
by(cut_facts_tac prem 1);
by(FOLD "%X.e->X" [LPref_elem] 1);
by(FOLD "%X.f->X" [LPref_elem] 1);
by(rtac R1 1);
by(ALLGOALS(asm_simp_tac(list_ss addsimps [restrict_Cons,restrict_Nil,Neq_commute])));
val R1_pref = result();


val prem = goal CspTransfo1.thy 
"[|(P|]A[|SKIP)=P;(Q|]A[|SKIP)=Q|] ==> ((P|~|Q)|]A[|SKIP)=(P|~|Q)";
by(asm_simp_tac(HOL_ss addsimps prem@[par_int_ndet_distrib1])1);
val AlphNdet=result();


val cont_ss =cont_ss addsimps [cont_Lpref];


val Alph_ss = cont_ss addsimps    
      [NelemAlphRec,AlphDet,AlphNdet,AlphInterl,AlphParInt,AlphRenF,
       prefix_Par_Int_skip,Lpref_Par_Int_skip1,Lpref_Nil,
       restrict_Cons,restrict_Nil];


