CspTransfo1 = ArithM + Laws +

consts
 
  Foldr     :: "[['a,'b] => 'b, 'a list, 'b] => 'b"
  "@->"     :: "['a list, 'a process] => 'a process" (infixl 70)

primrec "Foldr" list
  Foldr_Nil      "Foldr f [] b = b"
  Foldr_Cons     "Foldr f (a # s) b   = f a (Foldr f s b)"
defs

LPrefix_def "L @-> P == Foldr (% a P.a->P) L P"
 

rules


R7 "[|P|]C[|SKIP=P;Q|]A[|SKIP=Q;A Int B = {};C Int B = {} |] ==> ((P\\A)|]B[|(Q\\C))=(P|]B[|Q)\\(A Un C)"

R3 "[|c1~=c2; P1|]{c1,c2}[|SKIP=P1; P2|]{c1,c2}[|SKIP=P2|] ==>
    P1 ||| P2 << ((((P1[c1<-a1]) ||| (P2[c2<-a2]))
                               |]{c1,c2}[|
                     (/X. ((c1 ->(a1 -> X)) |] (c2 ->(a2 -> X))))) \\ {c1,c2})"

R6 "[|P1|]A2[|SKIP=P1; Q1|]A2[|SKIP=Q1; P2|]A1[|SKIP=P2; Q2|]A1[|SKIP=Q2|] ==>
    (P1 |]A1[| Q1) ||| (P2 |]A2[| Q2) = ((P1 ||| P2)|]A1 Un A2[| (Q1 ||| Q2))" 


(* Alphabet rules *)

AlphDet "[|P|]A[|SKIP=P;Q|]A[|SKIP=Q|] ==> (P|]Q)|]A[|SKIP=(P|]Q)"
AlphInterl "[|P|]A[|SKIP=P;Q|]A[|SKIP=Q|] ==> (P|||Q)|]A[|SKIP=(P|||Q)"
AlphParInt "[|P|]A[|SKIP=P;Q|]A[|SKIP=Q|] ==> (P|]B[|Q)|]A[|SKIP=(P|]B[|Q)"
AlphRenF "[|P|]A[|SKIP=P;b~:A|] ==> (P[b<-a])|]A[|SKIP=(P[b<-a])"

(*cont*)
    renam_cont	"[|cont f; finitary g|] ==> cont (%x. (f x) [.g.])"
    renamF_cont	"cont f ==> cont (%x. (f x) [b<-a])"

(* RenamingF *)

RenRecPref "cont f ==>
           (/X.a->(f X))[c<-b] =(/X.(if a=b then c else a)->((f X)[c<-b]))"
RenRecLpref "cont f ==>
           (/X.(a#l)@->(f X))[c<-b] =
           (/X.(if a=b then [c] else [a])@->((l@->(f X))[c<-b]))"
RenFPref "((a -> P)[c<-b])=((if a=b then c else a)->(P[c<-b]))"
RenFLpref "(((a#l)@->P)[c<-b])=((if a=b then [c] else [a])@->((l@->P)[c<-b]))"
end

