Programs = WF + 

(* ************************************************************************* *)
(*									     *)
(* Object-logical Interface for HOL for the code-generator.                  *)
(* Used to distinguish executable code                                       *)
(* Author: B. Wolff							     *)
(* 									     *)
(* ************************************************************************* *)

(* semantics *)

consts
  fun_decl :: "['c => 'd, ('a => 'b) => ('a => 'b), \
               \ ('a => 'b) => 'c => 'd,('a * 'a) set] => bool"
  val_decl :: "['a , 'a] => bool"

defs
  fun_decl_def "fun_decl c rec E measure == 
		  (c =(let r = wfrec measure rec in E r) & wf measure)"
  val_decl_def "val_decl c E == (c = E)"
					 


(* syntax *)

types
  mletbinds  mletbind

syntax
  "_mbind"      :: [pttrn, 'a] => mletbind           ("(2_ =/ _)" 10)
  ""            :: mletbind => mletbinds             ("_")
  "_mbinds"     :: [mletbind, mletbinds] => mletbinds("_;/ _")

  "_Fun"        :: [idt,mletbinds,'a,'b] => bool              
		      ("(fun (_) = letrec (_) in (_) measure (_))" 10)





translations
  "_Fun c (_mbind f E) F M"		=> "fun_decl c (%f.E) (F f) M"
(*
  "_Fun c E M"		<= "fun_decl c (%d.E) M" 

  (* letzteres muss vermutlich mit print_translation nachbehandelt werden... *)

*)


end
