(*****************************************************************************
 * 
 * SoPC -- split of postcondition
 *      -- another transformation for YATS (tm) 
 *      -- $Id: SoPC.thy,v 1.4 1997/10/07 11:26:08 tm Exp $
 *
 *****************************************************************************)

SoPC = FixRec + Nat + 

consts

(*
 * The three applicability conditions
 *)

   ESatInv :: "[ ['S, 'R] => bool,      \
             \   'S => 'R               \
             \ ] => bool"

   HSatInv :: "[ ['S, 'R] => bool,      \
             \   ['S, 'R] => bool,      \
             \   ['S, 'R] => 'R         \
             \ ] => bool"

   EHSatB  :: "   [ ['S, 'R]=> bool,    \
                \   'S => 'R,           \
                \   ['S, 'R] => 'R      \
                \ ] => bool"

(*
 * Das theory
 *)

  SoPC ::  " [ ['S, 'R] => bool,    \
           \   ['S, 'R] => bool,    \
	   \   'S => 'R,            \
           \   [ 'S, 'R] => 'R      \
           \ ] => bool"

 
(*
 * Aux. function: the iterator for natural numbers
 *)
    nat_it :: "[nat, 'a, 'a => 'a] => 'a"
  


defs

   SoPC_def
        "SoPC I B E H == (ESatInv I E) & (HSatInv I B H) & (EHSatB B E H)" 

   ESatInv_def
	"ESatInv I E   == ! x. I x (E x)"

   HSatInv_def
	"HSatInv I B H == ! x y. (I x y) & ~ (B x y)--> (I x (H x y))"

   EHSatB_def
	"EHSatB B E H  ==  ! x. ? i::nat. B x (nat_it i (E x) (H x))"     

   nat_it_def
        "nat_it n e f  == nat_rec e (%i::nat. f) n"

  
rules

   split_of_post  "! I B E H.
        SoPC I B E H --> 
                ((! z x. z = (f x) --> I x z & B x z)       
                      =
                 (? g.  (! x y.(g x y) 
                           = 
                            (if (B x y) then y  
                                            else (g x (H x y)))) & 
                                             (! x. (f x)= (g x (E x)))))"





   split_of_post2 "! I B E H. 
	SoPC I B E H -->
		(! z x. z = (f x) --> I x z & B x z)
			= 
		(f = (letrec g = (% x y.if (B x y) then y
						    else (g x (H x y)))
		      in (% x.g x (E x))))"

   split_of_post3 "! I B E H. 
	SoPC I B E H -->
		(! z x. z = (f x) --> I x z & B x z)
			= 
		(f = (letrec g = (% x y.if (B x y) then y
						    else (g x (H x y)));
			     f = % x.g x (E x)
		      in f))"

end
