(* *********************************************************************** *)
(*									   *)
(* Project: sml/Tk: an Tk Toolkit for sml	 			   *)
(* Author: Burkhart Wolff, University of Bremen	 			   *)
(* Date: 25.7.95				 			   *)
(* Purpose of this file: Little stand-alone interactive search-tool        *)
(* 			 of theories and theorems in the Isabelle-data-base*)
(*									   *)
(* NOTE: This code must be executed under Isabelle/HOL, rsp. under control *)
(* 	 of ROOT.ML of sml_tk						   *)
(*									   *)
(* *********************************************************************** *)


(*  This construction does not work for mysterious reasons
    (sharing constraints on bad_regexp ok??? 

structure ChooserN : sig val chooser : unit -> (string * thm) list end =
struct

val SEL_THY 	= ref ([] : (string * theory) list);
val SEL_THMS 	= ref ([] : (string * thm) list);

exception bad_regexp;

structure ChooserN2 = Chooser(
structure M = 
struct
	open BasicTypes
	val rex_filter = default_match;
	exception bad_regexp;
	(*   val bad_regexp = bad_regexp; ?! *)
	val SEL_THY = SEL_THY;
	val SEL_THMS = SEL_THMS;
	fun refresh () = ()
end;
);

fun chooser () = (SysInit.initSmlTk();ChooserN2.chooser())

end;

*)

structure Chooser : sig val chooser : unit -> (string * thm) list end =
struct

val SEL_THY 	= ref ([] : (string * theory) list);
val SEL_THMS 	= ref ([] : (string * thm) list);

exception bad_regexp;

structure ChooserN = ClipChooser (structure M= 
		  struct 
		     open BasicTypes
		     val rex_filter = default_match
		     exception bad_regexp
		     val bad_regexp   = bad_regexp
		     val SEL_THY      = SEL_THY
		     val SEL_THMS     = SEL_THMS
	             fun refresh () = ()
		     structure CB= DummyCB
		     val thyToObj    = K ()
		     val thmToObj     = K ()
		  end);

fun chooser () = (SysInit.initSmlTk();ChooserN.chooser())

end;

