(* *********************************************************************** *)
(*									   *)
(* Project: sml/Tk: an Tk Toolkit for sml	 			   *)
(* Author: Burkhart Wolff, University of Bremen	 			   *)
(* Date: 25.7.95				 			   *)
(* Purpose of this file: Little stand-alone interactive search-tool        *)
(* 			 of theories and theorems in the Isabelle-data-base*)
(*									   *)
(* NOTE: This code must be executed under Isabelle/HOL, rsp. under control *)
(* 	 of ROOT.ML of sml_tk						   *)
(*									   *)
(* *********************************************************************** *)

structure ExChooser =
struct

val SEL_THY 	= ref ([] : (string * theory) list);
val SEL_THMS 	= ref ([] : (string * thm) list);

fun refresh () = ();

structure Chooser = Chooser(structure M = struct 
					val rex_filter = default_match;
					exception bad_regexp;
					val SEL_THY = SEL_THY;
					val SEL_THMS = SEL_THMS;
					val refresh = refresh;
				      end);

fun doit () = (SysInit.initSmlTk();Chooser.chooser())

end;

