(*************************************************************************)
(*   Title              : ROOT.ML                                        *)
(*   Project            : Encoding Z in Isabelle                         *)
(*   Author             : T. Santen GMD First                            *)
(*   This File          : Root file to load Z in Isabelle/HOL            *)
(*   $Id: ROOT.ML,v 1.2.2.2 1998/09/18 15:19:17 kol Exp $  *)
(*   Copyright          : BISS, University of Bremen                     *)
(*                        GMD First, Berlin                              *)
(*                        Germany                                        *)
(*************************************************************************)

(* *********************************************************************** *)
(* Read the HOL-Contributions                                              *)
(* *********************************************************************** *)
loadpath:= !loadpath @ ["/usr/local/software/isabelle/Isabelle94-7/HOL/Integ"];

val actualdir = pwd();
val zdir = "../../isa_lang/Z";
cd zdir;

use_dir "contrib";          (* Z contributions to standard Isabelle theories*)
                            (* Independent of kernel and Z-Loader *)

(* *********************************************************************** *)
(* Generate the Kernel of the Embedding                                    *)
(* *********************************************************************** *)

use "ZPrelude.sml";          (* General functionality, strokes *)
use "ZEnv.sml";              (* Environment *)
use "ZTheory.sml";           (* Z-Theories *)
use "ZSchemaSign.sml";       (* computing signatures of some *) 
                             (* ... syntactic categories *)
use "ZEncoder.sml";          (* parser,reader and add_scheme for Z-Objects *)
use_thy "ZPure";             (* load Z kernel *)

(* *********************************************************************** *)
(* Generate the Z-Loader                                                   *)
(* *********************************************************************** *)

use_dir "zthy";

(* *********************************************************************** *)
(* Generate the Z Mathematical Tool-Kit                                    *)
(* *********************************************************************** *)

use_dir "lib";              (* Independent of Kernel and Z-Loader *)
use_thy "Z";


(* *********************************************************************** *)
(* Generating Z-provers                                                    *)
(* *********************************************************************** *)

use_dir "prover";

(* *********************************************************************** *)
(* Finish setup                                                            *)
(* *********************************************************************** *)

init_zthy_reader ();        (* initializes Z-thy database *)
show_full_sem:=false;       (* pretty - printing on *)


(* *********************************************************************** *)
(* Check HOL-Z                                                             *)
(* *********************************************************************** *)

 
cd "examples";
delete_ztmpfiles:=false;
use_zthy "BB";
use_zthy"Steam";
cd zdir;
cd actualdir;

(*RAddBirthday_def;
delete_ztmpfiles:=true;
*)

(*
(* *********************************************************************** *)
(* Check HOL-Z                                                             *)
(* *********************************************************************** *)
cd "Zwin";

val zwindir = pwd();

use"root.sml";
open IsaZ;



(* 
  
cd "bin";
xML "HOL-Z" "Z in Isabelle/HOL";

*)
*)
