
val hurx = prove_goalw ZPure.thy [SB_def,split_def]
"(!!x y.  f x y) ==> ((SBinder A f) x)"
(fn [prem] => [rtac prem 1]);

val hurx' = prove_goalw ZPure.thy [SB0_def,split_def]
"(!!x.  f x) ==> ((SBinder0 A f) x)"
(fn [prem] => [rtac prem 1]);


fun strip_sbinder i =
    let val t = Lib.List.nth(prems_of(topthm ()),i-1);
        val Const ("Trueprop",_) $ (Const("All",_) $ t) = t;
        fun vars ((Const ("SBinder",_))$ t $ Abs (_,_,t')) =
     		   [String2string t] @ (vars t')
          | vars ((Const ("SBinder0",_))$ t $ Abs (_,_,t'))=
       		   [String2string t]
          | vars _ = [];
        val params = foldl (fn (s,s') => s ^ " " ^ s') ("",vars t)
    in  EVERY[rtac allI i,
    	      REPEAT((rtac hurx i) ORELSE(rtac hurx' i)),
    	      SELECT_GOAL prune_params_tac i,
    	      rename_tac params i]
    end;


(************* attemps to define a Z simplifier sets **)



fun repeatConjETac i = (REPEAT (etac conjE i))
fun repeatDeferTac i = (REPEAT((rtac conjI 1) THEN (defer_tac i)));

goal Set.thy "~(B <= A) --> A ~= A Un B";
br impI 1;
br rev_contrapos 1;
ba 2;
by(UNFOLD "A" [] 1);
by(fast_tac set_cs 1);
val subsetUnion = (result() RS mp);

val zmath_ss = simpset_of "ZMathTool";




(*
fun expand_schema thm i = 
	((Basic_zproof.expand_schema thm i) THEN (simp_tac Z2HOL_ss  i));
*)

val  expand_schema = Basic_zproof.expand_schema;

(*	
	
zgoal BB.zthy 
"AddBirthday --> (+.. %Delta BirthdayBook |--- (known ~= known') ---)";
by (strip_sbinder 1);
by (expand_schema AddBirthday_def 1);
by (expand_schema BirthdayBook_def 1);
by (simp_tac Z2HOL_ss  1);
br impI 1;
by (REPEAT (etac conjE 1));
by (REPEAT((rtac conjI 1) THEN (defer_tac 1)));
by (Fast_tac 2);
by (Fast_tac 2);
by (Fast_tac 2);
by (asm_full_simp_tac zmath_ss 1);
br subsetUnion 1;
by (Fast_tac 1);
val known_greater = result();




(*****************************************************************************)
(*****			precondition of AddBirthday ***********)
(*****************************************************************************)




zgoal BB.zthy 
"(+.. BirthdayBook |--- date_i: Date & name_i:Name ---) --> (+.. |--- AddBirthday = (name_i ~: known) ---)";

by(strip_sbinder 1);
by (expand_schema(AddBirthday_def) 1);
by (expand_schema(BirthdayBook_def) 1);
by (simp_tac Z2HOL_ss  1);
br impI 1;
br iffI 1;
by (Fast_tac 1);
by (asm_simp_tac HOL_ss 1);
br conjI 1;
by (Fast_tac 2);
by(REPEAT (etac conjE 1));
by (simp_tac (Z2HOL_ss addsimps [dom_distr]) 1);


by(REPEAT (etac conjE 2));
by(ALLGOALS(fn i => REPEAT(rtac conjI i)));
by(ALLGOALS(fn i => REPEAT(rtac conjI i)));
by(ALLGOALS(fn i => REPEAT(rtac conjI i)));
by(ALLGOALS(fn i => REPEAT(rtac conjI i)));
by(ALLGOALS(fn i => REPEAT(rtac conjI i)));
by (Fast_tac 1);
by (Fast_tac 4);
by (Fast_tac 3);
by (asm_full_simp_tac zmath_ss 5);
by (asm_full_simp_tac zmath_ss 4);

by (fast_tac HOL_cs 1); 

br conjI 1;
br conjI 2;
by (Fast_tac 1);
by (Fast_tac 1);





*)
