


(* -- ? 
cd "/home/bu/uniform/isa_lang/CSP/univ_csp/examples" ;
use_thy "Exa1";
 *)



(*
val prem = goalw Ex1.thy [] 
"finite (SYN::(channel*'a)set) ==> SYSTEM << (COPY::(channel*'a) process)";

val prf = save_proof();
*)

val cont_ss = cont_ss addsimps prem;

val huge_ss = merge_ss(set_ss,prod_ss)
       		addsimps([Un_def,subset_spec,empty_spec,
			  Collect_eq_spec,strange_lemma,
                 	  Int_def,SYN_def]@channel.simps) 
		addcongs [conj_cong];

val UU_ss = (merge_ss(set_ss,prod_ss) addsimps
                 [UU_pair_def,UU_process_def,SYN_def,
                  hide_set_bot,par_Int_bot,
		  Bot_is_least,split_eq_fst_snd]);

(*
evtl auf die flaeche:
mono_mprefix_ref
hide_prefix_distr1
mprefix_Par_Int_distr3
hide_mprefix_distr
mprefix_singl
mprefix_Par_Int_distr1
singleton_spec
conj_commute

*)

structure IsaCSP = 
    IsaWin(open IsaConfNormal
    	   open IsaWinTypes

	   val initConf = 
	       {thms =   [(SYSTEM_def, rewrRule,"SYSTEM_def"),
			  (COPY_def,   rewrRule, "COPY_def"),
			  (Let_def,    rewrRule, "Let_def"),
			  (Letrec_def, rewrRule, "Letrec_def"),
			  (fix_ind,    introThm, "fix_ind")],
	       clasets=  [(eq_cs, "eq_ss")],
	       simpsets= [(HOL_ss, "HOL_ss"),
			  (cont_ss, "cont_ss"),
			  (UU_ss,   "UU_ss"),
			  (huge_ss, "setE_ss")],
	       theories= [(Csp.thy, "Csp"), (Exa1.thy, "Exa1")],
	       texts=    [("finite (SYN::(channel*'a)set) ==>    \
		           \ SYSTEM << (COPY::(channel*'a) process)",
			   "refinement proof")],
	       goals= [],
	       substs=  [([("f","(%(SEND,REC). (?X SEND, ?Y REC))")], 
								"fix_redex")],
	       eta_contract= false}
	   )
	    



(* ***************************** *)
(* Example proof - for Demos ... *)
(* ***************************** 



val prem = goalw Exa1.thy [SYSTEM_def,COPY_def,Let_def,Letrec_def] 
"finite (SYN::(channel*'a)set) ==> SYSTEM << (COPY::(channel*'a) process)";
by(rtac fix_ind 1);
back();

(* reducing admissability ... *)
br adm_ref_ord 2;

(* fixpoint induction base ... *)
by(simp_tac(merge_ss(set_ss,prod_ss) addsimps
         [UU_pair_def,UU_process_def,SYN_def,
          hide_set_bot,par_Int_bot,Bot_is_least,split_eq_fst_snd])4);
by(asm_full_simp_tac (prod_ss addsimps [split_eq_fst_snd]) 4);

(* elemination of cont-assumptions ... *)
by(ALLGOALS(cont_tac prem));

(* fixpoint induction step ... ... *)

by(UNFOLD "?X" [knaster_tarski] 1);
by(asm_full_simp_tac (set_ss addsimps [read_def]) 2);


by(UNFOLD "(|] xa : ?A @ mid ! (snd xa) -> ?X xa) |]SYN[| ?Y" 
[mprefix_Par_Int_distr2] 2);

(* Elimination of side-condition 3 *)
by(simp_tac (HOL_ss addsimps [SYN_def]) 3);
by(fast_tac eq_cs 3);

(* ... continue main proof ...*)
by(FOLD "%xa.(mid ! snd xa -> (?X xa))" [mprefix_singl] 3);
by(UNFOLD "%xa. (|] xa : {(mid, snd xa)} @  (?X xa ))|] ?Y [| ?Z xa " 
   [mprefix_Par_Int_distr1] 3);
																					
(* simplify the communication *)
by(simp_tac ((merge_ss(prod_ss,set_ss) addsimps [Int_def,SYN_def]) addcongs [conj_cong]) 5);
by(simp_tac (prod_ss addsimps [singleton_spec,mprefix_singl]) 5);
by(fold_goals_tac [SYN_def]);
by(FOLD "%xa.(right ! (snd xa) -> (?X xa))" [mprefix_singl] 5);
by(FOLD "%xa.(right ! (snd xa) -> (?X xa))" [mprefix_singl] 5);
by(UNFOLD "(|] xa : {y. ((fst y) = left)} @ ?X xa)\\ ?Y" [hide_mprefix_distr] 5);
br mono_mprefix_ref 6;
by(UNFOLD "?X" [hide_prefix_distr1] 6);
by(UNFOLD "?X" [mprefix_Par_Int_distr3] 7);
by(UNFOLD "?Y" [hide_mprefix_distr] 9);
br mono_mprefix_ref 10;
by(FOLD "?X" [mprefix_singl] 10);
by(UNFOLD "?X" [mprefix_Par_Int_distr1] 10);
by(simp_tac ((merge_ss(prod_ss,set_ss) addsimps [Int_def,SYN_def]) addcongs [conj_cong]) 12);
by(FOLD "%xa x. (((fst x) = ack) & (x = (ack, (snd xa))))" [conj_commute] 12);
by(simp_tac ((merge_ss(prod_ss,set_ss) addsimps [singleton_spec,mprefix_singl]) addcongs [conj_cong]) 12);
by(fold_goals_tac [SYN_def]);
by(UNFOLD "?X" [hide_prefix_distr1] 12);
(* applying the induction hypothesis !!! *)
by(atac 13);

(* Global proof of all remaining applicability conditions wrt. sets *)
by(ALLGOALS(asm_simp_tac((merge_ss(set_ss,prod_ss)
       addsimps [Un_def,subset_spec,empty_spec,Collect_eq_spec,strange_lemma,
                 Int_def,SYN_def]@channel.simps) addcongs [conj_cong])));
by(UNFOLD "%x.fst x = mid & x = (right, snd xa)" [conj_commute] 2);
by(UNFOLD "%x.fst x = ack & x = (right, snd xa)" [conj_commute] 2);
by(ALLGOALS(asm_simp_tac((merge_ss(set_ss,prod_ss)
       addsimps [Un_def,subset_spec,empty_spec,Collect_eq_spec,strange_lemma,
                 Int_def,SYN_def]@channel.simps) addcongs [conj_cong])));
by(ALLGOALS(cont_tac prem));
qed "impl_refines_spec";



*)	   
	    

