(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/isa_win/main.sml,v $
    
   IsaWin main file. 

   This file creates the main part of IsaWin, to be used either 
   standalone or together with TAS. This file assumes the isa_toolkit
   is already loaded.

   $Date: 1998/09/11 09:08:47 $
   $Revision: 1.5.4.1 $
   Author: cxl (Last modification by $Author: cxl $)

   (C) 1996, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)

use "config.sig";


structure Thy =
    struct
	type theory= theory
	type proof = proof
	
	val goalw = goalw
	val push_proof    = push_proof
	val pop_proof     = pop_proof
	val restore_proof = restore_proof
	val save_proof    = save_proof

	fun thyToThy th   = th
    end;


use "sel_tactics.sml";
use "types.sml";
use "induct.sml";
use "widgets.sml";
use "area.sml";
use "appl.sml";
use "isawin.sml";

use "config.sml";


(* IsaWin for HOL *)
functor IsaWinHOL(conf: ISAWINCONF) = 
  IsaWin(	
	val initConf=
	    { thms = [(add_commute, IsaWinTypes.rewrRule, "add_commute"),
		      (add_0_right, IsaWinTypes.rewrRule, "add_0_right"),
		      (trans,       IsaWinTypes.rewrRule, "trans"),
		      (allI,        IsaWinTypes.introThm, "allI")], 
	     simpsets= [(HOL_ss, "HOL_ss"), (arith_ss,"Arith_ss")], 
	     clasets=  [(HOL_cs, "HOL_cs")], 
	     theories= [(Arith.thy, "Arith")],
	     substs=   [([("b","berta"),("a","alfa")], "ExSubst")],
	     texts=    [("(a::nat)*(x+y)= a*(y+x)", "wee_goal")],
	     goals=    [],
	     eta_contract= true
	     }
	open conf);
