(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/isa_win/set_config.sml,v $
    
   IsaWin -- setting different configurations. 

   This file provides various (erh, one at this point which moreover doesn't
   change anything, but hopefully that'll change) functions to set
   the configurations.
 
   $Date: 1997/03/22 18:32:06 $
   $Revision: 1.2 $
   Author: cxl (Last modification by $Author: cxl $)

   (C) 1996, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)

signature CONFIGS =
    sig
	val standard : unit-> unit
	val demo     : unit-> unit
    end

structure SetConfig  : CONFIGS =

struct

fun standard () = 

(Conf.Configuration := 
     {iconPath=     (Conf.IsaWinPath())^"icons/small",
      wsButtonFont= "-*-lucida?sans?typewriter-medium-r-*-*-12-*-*-*-*-*-*-*",
      wsMainFont=   "-misc-fixed-medium-*-*-*-14-*-*-*-*-*-iso8859-1",
      wsTitleFont=  "-adobe-courier-*-r-*--14-*-*-*-*-*-*-*"     
      };

 GenConf.Configuration :=
     {width=         700,
      height=        350,
      background=    Grey,
      iconNameFont=  "-adobe-courier-*-r-*--12-*-*-*-*-*-*-*",
      iconNameWidth= 80,
      trashcanIcon=  Icons.getIcon(SmlTk.getSrcPath()^"toolkit/icons", "trashcan.gif"),
      trashcanCoord= (650, 310),
      moveOpaque=    true, 
      oneWindow=     false,
      wsHeight=      350,
      wsWidth=       700,
      ttFont=       "-misc-fixed-medium-*-*-*-14-*-*-*-c-*-iso8859-*"
     };

 UtilWinConf.Configuration :=
     {msgWidth=      200 :int,
      msgFont=       "-*-lucidatypewriter-medium-*-*-*-15-*-*-*-*-*-iso8859-1",
      buttonWidth=   5:int,
      buttonFont=    "-*-lucidatypewriter-medium-*-*-*-15-*-*-*-*-*-iso8859-1",
      enterTextFont=  "-misc-fixed-medium-*-normal-*-14-*-*-*-c-*-iso8859-1",
      errorIconFilenm=   (SmlTk.getSrcPath())^"toolkit/images/stop.gif",
      warningIconFilenm= (SmlTk.getSrcPath())^"toolkit/images/warning.gif"
      };

 print "Standard setup selected.\n"
)

fun demo () = (

 raise Fail "Demo setup not implemented"

)

end
