val thy = mk_base [Thy "Csp"] "Exa1" true;

structure Exa1 =
struct

local
 val parse_ast_translation = [];
 val parse_translation = [];
 val print_translation = [];
 val print_ast_translation = [];
in



val thy = thy

|> add_trfuns
(parse_ast_translation, parse_translation, print_translation, print_ast_translation)

val (thy, channel_add_primrec) = Datatype.add_datatype
([], "channel", [("left", [], NoSyn), ("right", [], NoSyn), ("mid", [], NoSyn), ("ack", [], NoSyn)]) thy
val thy = thy

|> add_consts
[("SYSTEM", "(channel*'a) process", NoSyn),
 ("COPY", "(channel*'a) process", NoSyn),
 ("SYN", "(channel*'a) set", NoSyn)]

|> add_defs
[("COPY_def", " COPY   ==(letrec COPY = left ? x -> right ! x  -> COPY    in     COPY)"),
 ("SYN_def", " SYN    == {x. fst x = mid | fst x = ack}"),
 ("SYSTEM_def", " SYSTEM ==(letrec     SEND = left ? x -> mid ! x  -> ack ? y -> SEND;    REC  = mid ? x -> right ! x -> ack ! x -> REC    in     ((SEND |] SYN [| REC) \\ SYN))")]

|> add_thyname "Exa1";

val _ = store_theory (thy, "Exa1");


structure channel =
struct
 val inject = map (get_axiom thy) [];
 val distinct = let val distinct' = map (get_axiom thy) ["left_not_right", "left_not_mid", "left_not_ack", "right_not_mid", "right_not_ack", "mid_not_ack"]  in distinct' @ (map (fn t => sym COMP (t RS contrapos)) distinct') end;
 val induct = get_axiom thy "channel_induct";
 val cases = map (get_axiom thy) ["channel_case_left", "channel_case_right", "channel_case_mid", "channel_case_ack"];
 val recs = map (get_axiom thy) ["channel_rec_left", "channel_rec_right", "channel_rec_mid", "channel_rec_ack"];
 val simps = inject @ distinct @ cases @ recs;
 fun induct_tac a = res_inst_tac [("channel", a)] induct;
end;
val dummy = datatypes := Dtype.build_record (thy, ("channel", ["left", "right", "mid", "ack"]), channel.induct_tac) :: (!datatypes);
val dummy = Addsimps channel.simps;


val COPY_def = get_axiom thy "COPY_def";
val SYN_def = get_axiom thy "SYN_def";
val SYSTEM_def = get_axiom thy "SYSTEM_def";

end;
end;
