(* ***************************************************************************
 
   $Source: /home/uniform/rep/isa_gui/tas/tas_z.sml,v $
 
   TAS instantiation for the Z specification language. 

   This is built on top of HOL-Z, i.e. using a HOL-Z/Tk image.

   $Date: 1997/09/14 15:54:44 $
   $Revision: 1.7 $ 
   Author: cxl (Last modification by $Author: cxl $)

   (C) 1997, Bremen Institute for Safe Systems, Universitaet Bremen

  ************************************************************************** *)

(* Put trafo theories in loadpath *)

val trafodir= tasdir^"/../../isa_lang/Z";
val exdir=    tasdir^"/../../isa_lang/Z/examples";
val examples= tasdir^"/examples/Z";

 
let
    fun addel(e, l) = if exists (fn ee=>ee= e) l then l else e:: l
in                  
    loadpath  := addel(examples, addel(exdir, addel(trafodir, !loadpath)));
    loadzpath := !loadpath
end;


(* Load top theory *)
use_zthy "ZTrafos";

cd tasdir;


(* Load birthday book example *)
(* use_zthy"BB"; *)

       

(* Load trafos *)
use "trafos/un_fold.sml";
use "trafos/z_trafos.sml";

(* Load configuration *)
use "config.sml";

(* --- IsaWin for Z ------------------------------------------------------ *)
 
structure IsaZ = 
    IsaWin(open IsaConfNormal
    	   open IsaWinTypes

	   val initConf = 
	       {thms =   [],
	       clasets=  [],
	       simpsets= [],
	       theories= [],
	       texts=    [],
	       goals=    [],
	       substs=   []}
	   );
	    


(* --- Instantiate TAS ---------------------------------------------------- *)
structure TasZ= 
    TasAPI(structure TAS= TAS(structure trafothy = ZTrafoThy
    			      structure conf =    TasConfNormal
				                     (val examples_dir= 
							  "examples/Z")
			     structure isaWin = IsaZ
			    ));

(* Open TAS *)
open TasZ;

(* --- Example States ----------------------------------------------------- *)


(* --- Message ------------------------------------------------------------- *)

writeln "\n\n\
\TAS/Z is now set up.\n\
\Use start(); to start TAS with its initial state, and resume <state>; to \n\
\resume execution.\n";
