(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1997/05/26 15:09:15 $
  $Revision: 1.7 $
   Purpose of this file: Basic Library, Interface to routines of original
                         Gofer-standard-Prelude

   *********************************************************************** *)

signature BASIC_UTIL =
    sig
	exception GET 

	val prefix    : ''a list -> ''a list -> bool
	val isPrefix  : string-> string-> bool
	val get       : ('a -> bool) -> 'a list -> 'a 
	val getx      : ('a -> bool) -> 'a list -> exn -> 'a
	val delete    : ('a -> bool) -> 'a list -> 'a list
	val deleteEq  : ''a -> ''a list -> ''a list
	val updateFun : ('a -> bool) -> ('a -> 'a) -> 'a list -> 'a list	
	val updateVal : ('a -> bool) -> 'a -> 'a list -> 'a list
	val ELEM      : ''a * ''a list -> bool

	val dropWhile : ('a -> bool) -> 'a list -> 'a list
	val takeWhile : ('a -> bool) -> 'a list -> 'a list
	val span      : ('a -> bool) -> 'a list -> 'a list * 'a list
	val break     : ('a -> bool) -> 'a list -> 'a list * 'a list
	val fst       : 'a * 'b -> 'a
	val snd       : 'a * 'b -> 'b
	val /=        : ''a * ''a -> bool
	val filter    : ('a -> bool) -> 'a list -> 'a list
        val forall    : ('a -> bool) -> 'a list -> bool
        val foldr     : ('a * 'b -> 'b) -> 'a list * 'b -> 'b
        val foldl     : ('a -> 'b -> 'a) -> 'a -> 'b list -> 'a
        val foldl1    : ('a -> 'a -> 'a) -> 'a list -> 'a
        val concat    : string list -> string
	val concatWith: string-> string list-> string
	    (* concatInt str [s1,...,sn] = s1 str s2 str ... str sn *)
	val concatL   : 'a list list -> 'a list
	val flatten   : 'a list list -> 'a list
	val app       : ('a -> 'b) -> 'a list -> unit
	val sort      : ('a * 'a -> bool) -> 'a list -> 'a list
	val words     : string -> string list
	val zip       : ('a list * 'b list) -> ('a * 'b) list

	val --        : int * int-> int list 
	    (* should be `..', the range operator *)

        val atoi      : string-> int

	val C         : ('a-> 'b-> 'c)->'b->'a->'c
	val K	      : 'a-> 'b-> 'a
	val S	      : ('a -> 'b -> 'c) -> ('a -> 'b) -> 'a -> 'c
	val I         : 'a-> 'a
	val P         : ('a -> 'b) -> 'a -> 'c -> 'b

	(* A poor man's semaphore *)	    
	structure Sema : 
	    sig
		val P  : unit-> bool  (* true <==> access granted *)
		val V  : unit-> unit
	    end	

    end;
