(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1996/09/30 19:07:15 $
  $Revision: 1.3 $
   Purpose of this file: Functions related to "Tk-Bindings"

   *********************************************************************** *)

signature BIND =
    sig
	open BasicTypes

	val selKey    : Binding -> Key
	val selAction : Binding -> Action

	val getAction :  Key -> Binding list -> Action

	val noDblP    : Binding list -> bool

	val add       : Binding list -> Binding list -> Binding list
	val delete    : Binding list -> Binding list -> Key list

	val packWidget   : TclPath -> IntPath -> Binding list -> string list
	val packCanvas   : TclPath -> IntPath -> CItemId -> Binding list -> string list
	val packTag      : TclPath -> IntPath -> AnnId   -> Binding list -> string list

 	val unpackWidget : TclPath -> WidgetType -> Key list -> string list
(* 	val unpackCanvas : TclPath -> CItemId    -> Key list -> string  *)
    end
