(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1996/09/25 11:06:07 $
  $Revision: 1.2 $
   Purpose of this file: basic process control and communication routines

   *********************************************************************** *)

signature COM =
    sig
	open BasicTypes
	open BasicUtil

	val addApp    : AppId * program * protocolName * CallBack * QuitAction -> unit
	val addAppI   : App -> unit
	val removeApp : AppId -> unit

	val getApp    : AppId -> App

	val selAppId         : App -> AppId
	val selAppProt       : App -> outstream
	val selAppIn         : App -> outstream
	val selAppOut        : App -> instream
	val selAppCallBack   : App -> CallBack
	val selAppQuitAction : App -> QuitAction

(*
	val getProt    : unit -> outstream
	val getIn      : unit -> outstream
	val getOut     : unit -> instream
	val getAppProt : AppId -> outstream
	val getAppIn   : AppId -> outstream
	val getAppOut  : AppId -> instream
*)
	val getAppCallBack   : AppId -> CallBack
	val getAppQuitAction : AppId -> QuitAction


	val getLine   : unit -> string
	val getLineM  : unit -> string
	val putLine   : string -> unit
	val getLineApp  : AppId -> string
	val getLineMApp : AppId -> string
	val putLineApp  : AppId -> string -> unit

	val putTclCmd  : string -> unit
	val readTclVal : string -> string

	val commToTcl  : string
	val writeToTcl : string
	val writeMToTcl: string

	val initTcl  : CallBack -> bool
	val runTcl   : unit -> unit
	val exitTcl  : unit -> unit
	val resetTcl : unit -> unit
    end;
