(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1997/03/26 16:16:23 $
  $Revision: 1.7 $
   Purpose of this file: Functions related to "Tk-Configurations"

   *********************************************************************** *)

signature CONFIG =
    sig
	open BasicTypes

	val selWidth   : Widget -> int
	val selHeight  : Widget -> int
	val selRelief  : Widget -> RelKind
	val selText    : Widget -> string
	val selCommand : Widget -> SimpleAction

	val selMWidth   : MItem -> int
	val selMRelief  : MItem -> RelKind
	val selMText    : MItem -> string
	val selMCommand : MItem -> SimpleAction

	val confEq : Configure -> Configure -> bool
	val noDblP : Configure list -> bool

	val add    : Configure list -> Configure list -> Configure list 
	val new    : WidgetType -> Configure list -> Configure list -> Configure list 

	val pack   : IntPath -> Configure list -> string
	val packM  : IntPath -> int list -> Configure list -> string

	val readCascPath : string -> int list

	(* ### gehrt hier nicht her *)
	val packInfo : Pack list -> string

	val showIconKind         : IconKind -> string

	val showTextWidState   : bool -> string

	val winConfEq          : WinConfigure -> WinConfigure -> bool

	val addWinConf         : WinConfigure list -> WinConfigure list -> WinConfigure list

	val selWinAspect       : Window -> (int * int * int * int) SysDep.option
	val selWinGeometry     : Window -> (((int * int) SysDep.option) *
					    ((int * int) SysDep.option)   ) SysDep.option
(*	val selWinIcon         : Window -> IconKind                SysDep.option
	val selWinIconMask     : Window -> IconKind                SysDep.option
	val selWinIconName     : Window -> string                  SysDep.option
 *) 
	val selWinMaxSize      : Window -> (int * int)             SysDep.option
	val selWinMinSize      : Window -> (int * int)             SysDep.option 
	val selWinPositionFrom : Window -> UserKind                SysDep.option
	val selWinSizeFrom     : Window -> UserKind                SysDep.option
	val selWinTitle        : Window -> Title                   SysDep.option
	val selWinGroup        : Window -> WinId                   SysDep.option
	val selWinTransient    : Window -> WinId  SysDep.option    SysDep.option
	val selWinOverride     : Window -> bool                    SysDep.option

	val packWinConf : string -> WinConfigure -> string



    end
