(* ***************************************************************************
 
   $Source: /home/uniform/rep/sml/sml_tk/debug.sml,v $
 
   Structure for debugging output.
 
   $Date: 1997/11/14 10:42:51 $
   $Revision: 1.7 $
   Author: Stefan Westmeier (Last modification by $Author: cxl $)

   (C) 1996, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)


structure Debug : DEBUG = 
struct

    open BasicUtil

    val all    = [0]

    val debugs = ref ([]:int list)

    fun eq x y = (x= y)
	
    fun on  0 = debugs := all
      | on  l = (debugs := (l:: (!debugs)))
    
    fun off 0 = debugs := []
      | off l = (debugs := delete (eq l) (!debugs))

    fun print l s = if ((!debugs)= all) orelse
	               (List.exists (eq l) (!debugs))
		    then output(std_err, s^"\n") 
		    else ()

    val warnme = ref true

    fun warning msg = 
	if (!warnme) then output(std_err, "WARNING: "^msg^"\n")
	else ()

    fun warn_on () = warnme:= true

    fun warn_off ()= warnme:= false	
		    
    fun error msg  = output(std_err, "ERROR: "^msg^"\n")

end

