(* ***************************************************************************
 
   $Source: /home/uniform/rep/sml/sml_tk/sys_init.sml,v $
 
   One-line synopsis
  
   Slightly more detailed information, if necessary.
 
   $Date: 1997/11/14 10:42:57 $
   $Revision: 1.7 $
   $Author: cxl $

   (C) 1996, Bremen Institute for Safe Systems (BISS), University of Bremen. 

  ************************************************************************** *)

signature SYS_INIT =
sig
    val initSmlTk : unit -> unit
end;

structure SysInit : SYS_INIT =
struct

    open BasicTypes SysDep

    val oldDisplay = ref ""

    fun warnme msg = Debug.error (msg^" (sml_tk may malfunction)")

    fun checkUpdPaths () =
	(updLogfilename(SysConf.getProtPath());
	 updWishPath(SysConf.getTclPath());
	 updSrcPath(SysConf.getSmlTkPath());
	 updFntPath(SysConf.getFontPath());	 
	 let val wish_ok = isFileRdAndEx(getWishPath())
	     val font_ok = isFileRdAndEx(getFntPath())
	     val src_ok  = isDirRdAndWr(getSrcPath())
	 in
	     output(std_out, "\nsml_tk parameter settings:\n\
		             \--------------------------\n");
	     output(std_out, "wish       : "^(getWishPath())^	       
		     (if not wish_ok then 
			 " *** WARNING: no executable found!\n"
		      else "\n"));
	     output(std_out, "source dir : "^(getSrcPath())^
		     (if not src_ok then
			 " *** WARNING: not a r/w directory!\n" 
		      else "\n"));	      
	     if not font_ok then 
		  output(std_out, "*** WARNING: no executable `testfont` found at "^(getFntPath())^"\n")
	     else ();
	     output(std_out, "logfile    : "^(getLogfilename())^"\n");

	     if not (wish_ok andalso font_ok andalso src_ok) then
		  output(std_err, "Warnings occured, sml_tk malfunction likely.\n")
	     else ()
	 end)
	
    fun initSmlTk () =
	(
	 checkUpdPaths();

	 (* default initializiation for the wish *)       
	 updTclInit
	   " set tcl_prompt1 \"puts -nonewline {} \" \n \
	    \ set tcl_prompt2 \"puts -nonewline {} \" \n ";


	(* only if DISPLAY has changed, re-initialize fonts *)
	let val nuDisplay= SysConf.getDisplay()
	in  if nuDisplay= (!oldDisplay) then ()
	    else (oldDisplay:= nuDisplay; Fonts.init())
	end	           
       )

end
