(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
   Date: $Date: 1997/03/24 13:44:59 $
   Revision: $Revision: 1.27 $
   Purpose of this file: Test for Canvas and other new stuff ...

   *********************************************************************** *)

structure BigEx :
    sig val go : unit-> string end  =
struct 

open TkTypes SmlTk

(*
structure daVinciSMLTK :
sig
    val startDaVinci : unit -> unit
    val stopDaVinci  : unit -> unit
end
=
struct
    val appId = "DAVINCI"
    val prog  = ("/usr/local/software/daVinci/daVinci",["-pipe"])
    val prot  = "/tmp/g2da.log"

    fun callBack s = (insertTextEnd "aText" (s ^ "\n"))
    val quitAction = fn () => Com.putLineApp appId "quit";

    fun stopDaVinci () = Com.removeApp(appId)

    fun startDaVinci () = 
	let
        (* These two functions are not delivered with sml_tk .
         * They are intended to convert a file test2.nf into a string
         * representation of a graph which daVinci can understand
         *)
	    val g = FdrNf.parse("/home/stefan/bkb/sml/fdrnf/fdr-examples/test2.nf")
	    val s = StringGraph.graph2daVinci(g,"0")
	in
	    (addApp(appId,prog,prot,callBack,quitAction);
	     Com.putLineApp appId ("new_term_placed(" ^ s ^ ")") )
	end

end;

val startDaVinci = daVinciSMLTK.startDaVinci;
val stopDaVinci = daVinciSMLTK.stopDaVinci;
*)

(* *)
val startDaVinci = fn _ => (insertTextEnd "aText" "Start\n");
val stopDaVinci  = fn _ => (insertTextEnd "aText" "Stop\n");
(* *)


val doQuit       = fn () => closeWindow (mainWinId());
val doNoAction   = fn () => ();

fun aLabel () = Label("aLabel",[],[Text "My Example"],[]);

(* ----------------------------- hide Simple Widget ---------------------- *)

fun doHideButton () = (delWidget ("hiddenButton");
		       addConf "hideButton" [Text "Add"];
		       addConf "hideButton" [Command doAddButton] )

and doAddButton () = (addWidget (mainWinId()) "hider" (hiddenButton());
		      addConf "hideButton" [Text "Hide"];
		      addConf "hideButton" [Command doHideButton])

and hideButton hide = Button("hideButton",
			     [Side Left,Fill X,Expand true],
			     [Text "Hide",Command hide],[])

and hiddenButton () = Button("hiddenButton",
			     [Side Left,Fill X,Expand true],
			     [Text "ToHide",Command doNoAction],[]);

fun hider () = Frame("hider",
		     [hideButton doHideButton,
		      hiddenButton ()],
		      [Fill X],
		      [Relief Ridge,Borderwidth 2],[]);

(* ----------------------------- hide Recursive Widget ---------------------- *)

fun doHideFrame () = (delWidget ("hiddenFrame");
		      addConf "hideFrame" [Text "Add"];
		      addConf "hideFrame" [Command doAddFrame] )

and doAddFrame () = (addWidget (mainWinId()) "hider1" (hiddenFrame());
		     addConf "hideFrame" [Text "Hide"];
		     addConf "hideFrame" [Command doHideFrame])

and hideFrame hide = Button("hideFrame",
			    [Fill X,Expand true],
			    [Text "Hide",Command hide],[])

and hiddenButton1 x = Button("hiddenButton"^x,
			     [Side Left,Fill X,Expand true],
			     [Text ("ToHide"^x),Command doNoAction],[])

and hiddenFrame () = Frame("hiddenFrame",
			   [hiddenButton1 "A",hiddenButton1 "B"],
			   [Fill X],[Relief Ridge,Borderwidth 2],[]);

fun hider1 () = Frame("hider1",
		      [hideFrame doHideFrame,
		       hiddenFrame ()],
		      [Fill X],
		      [Relief Ridge,Borderwidth 2],[]);

(* ----------------------------- daVinci Starter ------------------------------ *)


fun bLabel() = Label("bLabel",[],[Text "Start daVinci"],[])

and doHideDaVinci () = (delWidget ("davi");delWidget ("texter"))

and bButton () = Button("daVinciHider",[Fill X],
			[Text "Hide daVinci",Command doHideDaVinci],[])

and daVinciButtonStart() = Button("daVinciButtonStart",[Fill X],
				  [Text "Start",Command startDaVinci],[])
and daVinciButtonStop() = Button("daVinciButtonStop",[Fill X],
				 [Text "Stop",Command stopDaVinci],[])

and daVinciStarter () = Frame("davi",[bLabel(),bButton(),
				      daVinciButtonStart(),daVinciButtonStop()],
			      [Fill X],
			      [Relief Ridge,Borderwidth 2],[])

and aText () = TextWid("aText",NoneScb,"",[],[Fill X],[Width 60,Height 10],[])

and texter() = Frame("texter",[aText()],[Fill X],[Relief Ridge,Borderwidth 2],[]);

fun entry () = Frame(newWidgetId (),
		     [Entry("entry",[Fill X],[],
			    [Bind("<Return>",
				  (fn (_) => 
				   let
				       val t = readTextAll "entry"
				   in
				       (deFocus "entry";
					addConf "mesCanFr" [Text ("Entered: \""^t^"\"")])
				   end)
				  )]
			    )],
		     [Fill X],[Relief Ridge,Borderwidth 2],[]);

val count = ref (0:int);
val pos   = ref (0,0);

fun canvasfr () = Frame("canvasfr",
			[canvas(),mesCanFr()],
			[Fill X],
			[Relief Ridge,Borderwidth 2],[])

and mesCanFr () = Message ("mesCanFr",
			   [Side Top,Fill X,Expand true],
			   [Width 350,Text "some Text"],
			   [])

and canvasItemsBindings wid cit = 			 
    [Bind ("<Enter>",enterIt wid cit),
     Bind ("<Leave>",leaveIt wid cit),
     Bind ("<Motion>",wrMotC wid cit),
     Bind ("<Shift-Button-3>",greyIt wid cit),
     Bind ("<Alt-Button-3>",displayWidth wid cit),
     Bind ("<Control-Button-3>",displayHeight wid cit),
     Bind ("<ButtonPress-3>",deleteIt wid cit),
     Bind ("<ButtonPress-1>",grabIt wid cit),
     Bind ("<ButtonRelease-1>",dropIt wid cit),
     Bind ("<Button1-Motion>",moveIt wid cit)]

and canvasItems (wid:WidId) = 
    [
(*
     CIcon("it0",(10,10),
	    FileImage((getSrcPath() ^ "tests+examples/teapot.gif"),"im1"),
	    [Anchor NorthWest],
	    canvasItemsBindings wid "it0"),
 *)
     COval("it1",(50,50),(100,100),
	    [FillColor Red,OutlineWidth 3],
	    canvasItemsBindings wid "it1"),
      CRectangle("it2",(200,200),(250,250),
		 [FillColor Red,Outline NoColor],
		 canvasItemsBindings wid "it2"),
      COval("it3",(50,200),(100,250),
	    [FillColor NoColor,Outline Green,OutlineWidth 3],
	    canvasItemsBindings wid "it3"),
      CLine("l1-2",[(75,75),(150,100),(200,150),(225,225)],
	    [FillColor Brown ,OutlineWidth 10,Smooth true],
	    canvasItemsBindings wid "l1-2"),
      CLine("l2-3",[(225,225),(75,225)],
	    [FillColor White ,OutlineWidth 3],
	    canvasItemsBindings wid "l2-3"),
      CLine("l3-1",[(75,225),(75,75)],
	    [FillColor Blue ,OutlineWidth 5],
	    canvasItemsBindings wid "l3-1"),
      CIcon("it4",(300,250),
	    FileBitmap (getSrcPath() ^ "tests+examples/myex.bmp"),
	    [Background Blue,Foreground Yellow,Anchor NorthWest],
	    canvasItemsBindings wid "it4"),
(*
      CIcon("it4a",(300,200),
	    FilePixmap (getSrcPath() ^ "tests+examples/gnu.xpm","im2"),
	    [Background Blue,Foreground Yellow,Anchor NorthWest],
	    canvasItemsBindings wid "it4a"),
 *)
      CWidget("it5",(250,100),newCItemFrameId(),
	      [Button("canvBut",[Fill X],
		      [Text "Add Subitem",
		       Command (fn () => addSubCanvas wid )],
		      [])],
	      [],
	      [Anchor NorthWest],
	      canvasItemsBindings wid "it5"),
      CWidget("it6",(200,10),newCItemFrameId(),
	      subCanvas wid "it6",
	      [Background Green],
	      [Anchor NorthWest,Width 200,Height 180],
	      canvasItemsBindings wid "it6"),
      CTag("its",["it1","it2","it3","it4","it5"])
      ]



and cnvDoHideButton (wid:WidId) (cid:CItemId)() = 
    (delWidget ("cnvHiddenButton");
     addConf "cnvHideButton" [Text "Add"];
     addConf "cnvHideButton" [Command (cnvDoAddButton wid cid)] )

and cnvDoAddButton (wid:WidId) (cid:CItemId) () =
    let
	val cit = getCItem wid cid
	val wi  = selItemWidId cit
	val p   = ".canvasfr.canvas.cnv." ^ wi ^ ".cnvHider"
    in
(*	(addWidget (mainWinId()) p (cnvHiddenButton());
 *)
	(addWidget (mainWinId()) "cnvHider" (cnvHiddenButton());
	 addConf "cnvHideButton" [Text "Hide"];
	 addConf "cnvHideButton" [Command (cnvDoHideButton wid cid)])
 
    end

and cnvHideButton hide = Button("cnvHideButton",
				[Side Left,Fill X,Expand true],
				[Text "Hide",Command hide],[])

and cnvHiddenButton () = Button("cnvHiddenButton",
				[Side Left,Fill X,Expand true],
				[Text "Delete",
				 Command (fn () => delCItem "c1" "it1")],
				[])

and testit () = (addConf "cnvHiddenButton" [Text "Deleted"])

and cnvHider (wid:WidId) (cid:CItemId) = 
    Frame("cnvHider",
	  [cnvHideButton (cnvDoHideButton wid cid),
	   cnvHiddenButton ()],
	  [Fill X,PadX 5,PadY 5],
	  [Relief Ridge,Borderwidth 2],[])

and cnvDeleter (wid:WidId) (cid:CItemId) =
    Button("cnvDeleter",
	   [Fill X,Expand true,PadX 5,PadY 5],
	   [Text "Quit Subitem",
	    Command (fn () => delCItem wid cid)],
	   [])

and subCanvas (wid:WidId) (cid:CItemId) = 
    [cnvHider wid cid,
     cnvDeleter wid cid,
     Canvas("c1",RightScb,
	    [ COval("it1",(25,25),(75,75),
		    [FillColor Red,OutlineWidth 3],
		    []) ],
	    [PadX 5,PadY 5],
	    [Background Yellow,Borderwidth 2,Relief Ridge],
	    [])]

and addSubCanvas (wid:WidId) =
    let
	val cid = newCItemId()
	val cit = CWidget(cid,(200,10),newCItemFrameId(),
			  subCanvas wid cid,
			  [Background Green],
			  [Anchor NorthWest,Width 200,Height 180],
			  canvasItemsBindings wid cid)
    in
	addCItem wid cit
    end
    

and canvas ()   = Canvas("canvas",
			 RightScb,
			 canvasItems "canvas",
			 [Side Top,Fill X,Expand true],
			 [Height 300,Width 200,Background Yellow,
			  Borderwidth 2,Relief Ridge],
			 [Bind("<ButtonPress-2>",addOneItem "canvas")])

and addOneItem (wid:WidId) (e:TkEvent) =
    let
	val x    = selXPos e
	val y    = selYPos e
	val ncid = newCItemId ();
	val ncit = COval(ncid,(x-25,y-25),(x+25,y+25),
			 [FillColor Red,OutlineWidth 3],
			 canvasItemsBindings wid ncid)
    in
	addCItem wid ncit
    end

and deleteIt (wid:WidId) (cid:CItemId) (_:TkEvent) =
    delCItem wid cid

and displayWidth (wid:WidId) (cid:CItemId) (_:TkEvent) =
    addConf "mesCanFr" [Text ("Item \""^cid^"\" has width: "^
				(makestring (readCItemWidth wid cid)))]

and displayHeight (wid:WidId) (cid:CItemId) (_:TkEvent) =
    addConf "mesCanFr" [Text ("Item \""^cid^"\" has height: "^
				(makestring (readCItemHeight wid cid)))]

and greyIt (wid:WidId) (cid:CItemId) (_:TkEvent) =
    (addCItemConf wid cid [FillColor Grey];
     addCItemBind wid cid [Bind ("<Shift-Button-3>",blueIt wid cid)])

and blueIt (wid:WidId) (cid:CItemId) (_:TkEvent) =
    (addCItemConf wid cid [FillColor Blue];
     addCItemBind wid cid [Bind ("<Shift-Button-3>",greyIt wid cid)])

and enterIt (wid:WidId) (cit:CItemId) (_:TkEvent) = 
    (addConf "mesCanFr" [Text ("<Enter Canvas Item(" ^ wid ^ "," ^ cit ^ ")>")];
     addConf wid [Cursor(XCursor("hand2",NONE))])

and grabIt (wid:WidId) (cid:CItemId) (TkEvent(_,_,x,y,_,_)) =
    (pos := (x,y);
     addConf wid [Cursor(XCursor("fleur",NONE))])

and moveIt (wid:WidId) (cid:CItemId) (TkEvent(_,_,x,y,_,_)) = 
    let
	val cit_col  = readCItemCoords wid cid
	val (xP,yP)  = !pos
	val _        = (pos:=(x,y))
	val delta    = (x-xP,y-yP)
	val cit_col' = map (addCoord delta) cit_col
	val t = "<Drag Canvas Item(" ^ (makestring x) ^ "," ^ 
	        (makestring y) ^ "," ^ wid ^ "," ^ cid ^ ") > " ^ 
		(makestring (!count))
	val _ = SysDep.inc count
    in
(*	(addConf "mesCanFr" [Text t]; 
 *)
        setCItemCoords wid cid cit_col' 
(*
         moveCItem wid cid delta
*)
    end

and dropIt (wid:WidId) (cid:CItemId) (TkEvent(_,_,x,y,_,_)) =
    addConf wid [Cursor(XCursor("hand2",NONE))]

and leaveIt (wid:WidId) (cit:CItemId) (_:TkEvent) = 
    (addConf "mesCanFr" [Text ("<Leave Canvas Item(" ^ wid ^ "," ^ cit ^ ")>")];
     addConf wid [Cursor(NoCursor)])

and wrMotC (wid:WidId) (cid:CItemId) (TkEvent(_,_,x,y,_,_)) = 
    let
	val t = "<Motion Canvas Item(" ^ (makestring x) ^ "," ^ 
	        (makestring y) ^ "," ^ wid ^ "," ^ cid ^ ") > " ^ 
		(makestring (!count))
	val _ = SysDep.inc count
    in 
	addConf "mesCanFr" [Text t]
    end
and wrEnt (_:TkEvent) = addConf "mesCanFr" [Text "<Enter>"]
and wrLea (_:TkEvent) = addConf "mesCanFr" [Text "<Leave>"]
and wrMot (_:TkEvent) = 
    let
	val t = "<Motion> " ^ (makestring (!count))
	val _ = SysDep.inc count
    in 
	addConf "mesCanFr" [Text t]
    end;

fun quitButton quit = Button("quitButton",
			     [Side Left,Fill X,Expand true],
			     [Text "Quit",Command quit,
			      Cursor(
				FileCursor(
				  getSrcPath() ^ 
				  "tests+examples/myex.cursor",
				  Blue,
                                  SOME(getSrcPath() ^ 
				       "tests+examples/myex.cursor_mask",
                                  Yellow)))],[])

fun quitter () = Frame("quitter",
		       [quitButton doQuit],
		       [Fill X],
		       [Relief Ridge,Borderwidth 2],[]);

fun initwin _ = [(mainWinId(), 
		 [WinTitle "Hider Example",
		  WinSizeFrom Program,
	          WinGeometry(NONE,SOME(50,50))], 
		[aLabel(),hider(),hider1(),daVinciStarter(),texter(),
		 entry(),canvasfr(),quitter()],
		doNoAction)];

val go = fn () => startTclExn (initwin ())


end;
