
(* *********************************************************************** *)
(*									   *)
(* Project: sml/Tk: an Tk Toolkit for sml	 			   *)
(* Author: Burkhart Wolff, University of Bremen	 			   *)
(* Date: 25.7.95				 			   *)
(* Purpose of this file: Small example					   *)
(*									   *)
(* *********************************************************************** *)

structure Ex1 =
struct

local open SysDep in
local open BasicTypes in
local open SmlTk in

val yesquit  = fn () => closeWindow "main"; 
val nogoon   = fn () => closeWindow "warning";
val noaction = fn () => ();    




(* Warning Window *)
fun nobut   msg yes no = Button("no",[Side Right, Fill X, Expand true],
			[Text "NO",  Command  no],[]);

fun message msg yes no = Label("l1",[Fill X, Expand true],
				[Text msg, Relief Flat, Width 25],[]);
fun yesbut  msg yes no = Button("yes",[Side Left,  Fill X, Expand true],
					[Text "YES", Command yes],[]);
fun yesno   msg yes no = Frame("yn",[yesbut msg yes no, nobut msg yes no],
				[],[],[]);

fun tree2   msg yes no = [message msg yes no, yesno msg yes no];


fun warnwin msg yes no = ("warning", 
			  [WinTitle "Warning", WinTransient (SOME "main"),
			   WinOverride true], 
			  tree2 msg yes no,noaction);

fun warning msg yes no = openWindow (warnwin msg yes no);



(* Enter Window *)
val inputok  = fn () => let val nm = readTextAll "e1" in
		  changeTitle "main" nm ;closeWindow "entername" end;
val nlabel   = Label("l2",[Side Left],[Text "name:"],[]);
val input    = Entry("e1",[],[Width 20],
		     [Bind("<Return>",(fn (_:TkEvent) => inputok()))]);
val treesize = [nlabel,input];

val enterwin = ("entername", 
		[WinTitle "Please enter name",WinTransient (SOME "main")], 
		treesize,noaction);
val playername= fn () => openWindow enterwin;

(* Main Window *)

val entername= MCommand [Text "Enter name", Command playername];

val m1 = newWidgetId();
val player   = Menubutton(m1,true,[entername],[],[Text "Special"],[]);
val yesreset = noaction;

val newgame  = fn() => warning "really reset?" yesreset nogoon;

val new      = MCommand	  [Text "New", Command newgame];

val quitgame = fn () => warning "really quit?"  yesquit  nogoon;

val quit     = MCommand([Text "Quit", Command quitgame]); 

val m2 	     = newWidgetId();
val game     = Menubutton(m2,true,[new, MSeparator, quit],[Side Left],
		[Text "Control"],[]);

val menu     = Frame("menu",[game, player],[],[],[]);

val board    = Frame("fr1",[],[Side Left, Fill X],[Width 200,Height 200], []);

val tree1    = [menu,board];

val initwin  = [("main", [WinTitle "Transformation System"], tree1,noaction)];


val doit = fn () => startTclExn initwin


end; end; end;

end;

