
structure ListBoxEx :
    sig val go : unit -> string end =
struct

open TkTypes SmlTk

val marks = ref (MarkEnd,MarkEnd);

structure WarnWin :
sig
    val warn : string -> unit
end
=
    struct
	val nogoon   = fn () => closeWindow "warning";
	val noaction = fn () => ();    

	fun message msg yes no = Label("l1",[Fill X, Expand true],
				       [Text msg, Relief Flat, Width 25],[]);
	fun yesbut  msg yes no = Button("yes",[Side Left,  Fill X, Expand true],
					[Text "Ok", Command yes],[]);
	fun yesno   msg yes no = Frame("yn",[yesbut msg yes no],
				       [],[],[]);

	fun tree2   msg yes no = [message msg yes no, yesno msg yes no];

	fun warnwin msg yes no = ("warning", [WinTitle "Warning"],tree2 msg yes no,noaction);

	fun warning msg yes no = openWindow (warnwin msg yes no);

	fun warn s = warning s nogoon noaction;
    end;


val doQuit       = fn () => closeWindow (mainWinId());
val doNoAction   = fn () => ();


fun doSelect () = 
    let
	val ms  = readSelRange "lister"
	val cm  = fn (a,MarkEnd) => (a,a)
		   | (a,b)       => (a,b)
	val sel = fn [m] => (marks:=m;readText "lister" (cm(m)))
                   | _   => ""
	val se  = sel ms
    in
        WarnWin.warn se
    end

and lister () = Listbox("lister",RightScb,
			[Fill X],
			[Relief Ridge,Borderwidth 2],
			[Bind("Double-Button-2",(fn (_:TkEvent) => doSelect()))])

and doFill () = BasicUtil.app (insertTextEnd "lister") ["aaa","bbb","ccc"] 

and fillButton fill = Button("fillButton",
			     [Side Left,Fill X,Expand true],
			     [Text "Fill",Command fill],[])

and filler () = Frame("filler",
		       [fillButton doFill],
		       [Fill X],
		       [Relief Ridge,Borderwidth 2],[])

and selButton fill = Button("selButton",
			    [Side Left,Fill X,Expand true],
			    [Text "Select",Command fill],[])

and selector () = Frame("selector",
			[selButton doSelect],
			[Fill X],
			[Relief Ridge,Borderwidth 2],[])


and quitButton quit = Button("quitButton",
			     [Side Left,Fill X,Expand true],
			     [Text "Quit",Command quit],[])

and quitter () = Frame("quitter",
		       [quitButton doQuit],
		       [Fill X],
		       [Relief Ridge,Borderwidth 2],[]);

val initwin = [(mainWinId(), [WinTitle "ListBox Example"],
		[lister(),filler(),selector(),quitter()],
		doNoAction)];

val go = fn () => startTclExn initwin


end;

