(* ***************************************************************************
 
   $Source: /home/uniform/rep/sml/sml_tk/tests+examples/small_ex.sml,v $
 
   The small running example from the documentation. 
 
   $Date: 1996/09/25 11:07:05 $
   $Revision: 1.2 $
   Author: bu/cxl (Last modification by $Author: cxl $)

   (C) 1996, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)

(*
 * This small example opens a window with a label, a text entry box and
 * a quit button. (See the documentation in ../doc/DOC.html.)
 *)


let

(* open sml_tk: *)

open TkTypes SmlTk

(* Get names for named objects: *)

val mainID  = mainWinId()
val entID   = newWidgetId()

(* Define the widgets: *)
val label   = Label(newWidgetId(), [Side Left], [Text "name:"], [])
val input   = let fun endInput _ = changeTitle mainID (readTextAll entID)
              in  Entry(entID, [], [Width 20], [Bind("<Return>", endInput)])
              end
val quit    = let fun stop _ = closeWindow mainID
	      in Button(newWidgetId(), [Side Bottom], [Text "Quit", Command stop], []) 
	      end

(* Group together the text entry and the label *)
val topblock = Frame(newWidgetId(), [label, input], [Side Top], [], [])

(* Define the main window *)
val enterwin = (mainID, "Please enter name", [topblock, quit], fn _ => ())

in

(* ... and go! *)
startTcl [enterwin]

end;

