(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
  $Date: 1996/06/19 11:53:58 $
  $Revision: 1.6 $
   Purpose of this file: Functions related to TkEvents

   *********************************************************************** *)

structure TkEvent : TK_EVENT = 
struct

infix 1 ELEM;
infix 1 /=;
nonfix prefix;

local open BasicTypes in

(* val split : (char -> bool) -> string -> string list *)
fun split p s    = 
    let
	fun splitS s = 
	    case BasicUtil.dropWhile p s of
		[] => []
	      | s1 => let 
			  val (w,s2) = BasicUtil.break p s1
		      in 
			  (implode w) :: (splitS s2) 
		      end
    in
	splitS (explode s)
    end;

fun selButton   (TkEvent(b,_,_,_,_,_)) = b

fun selState    (TkEvent(_,s,_,_,_,_)) = s

fun selXPos     (TkEvent(_,_,x,_,_,_)) = x

fun selYPos     (TkEvent(_,_,_,y,_,_)) = y

fun selXRootPos (TkEvent(_,_,_,_,x,_)) = x

fun selYRootPos (TkEvent(_,_,_,_,_,y)) = y

fun show () = "(%b,%s,%x,%y,%X,%Y)"

fun unparse ev_v = 
    let
	val ev_v' = BasicUtil.filter 
	            (fn c => ( (((op not) o SysDep.isOpenParen) c) andalso 
			       (((op not) o SysDep.isCloseParen) c) ))
		    (explode ev_v)
	val ev_vl = split SysDep.isComma (implode ev_v')
	val b     = SysDep.numval(explode(SysDep.nth(ev_vl,0)))
	val st    = SysDep.nth(ev_vl,1)
	val x     = SysDep.numval(explode(SysDep.nth(ev_vl,2)))
	val y     = SysDep.numval(explode(SysDep.nth(ev_vl,3)))
	val x_root= SysDep.numval(explode(SysDep.nth(ev_vl,4)))
	val y_root= SysDep.numval(explode(SysDep.nth(ev_vl,5)))
    in
	TkEvent(b,st,x,y,x_root,y_root)
    end

end;

end;



