(* ***************************************************************************
 
   $Source: /home/uniform/rep/sml/sml_tk/toolkit/tests+examples/stdmark_ex.sml,v $
 
   sml_tk Standard Markup Language: an example.

   $Date: 1997/07/25 09:17:30 $
   $Revision: 1.6 $
   Author: cxl (Last modification by $Author: cxl $)

   (C) 1997, Bremen Institute for Safe Systems, Universitaet Bremen
 
  ************************************************************************** *)


structure StdMarkEx : sig val go : unit-> unit end =

    struct

    open TkTypes SmlTk 

    val sometext = 
	"One can do <font bold>boldfaced<\\font> bits, and <font em>italic<\\font> bits.\n"^
	"One can make things <font large>larger<\\font> and <font tiny>smaller<\\font>.\n"^
	"There are <font tt>different<\\font> typefaces as well, such as that and <font sf>sans-serif<\\font>, and of course, <font symb>symbols<\\font>!\n"^
	"And <font bold sf>all these things <\\font>can be <font bold it>combined<\\font>.\n"^
	"Did I <box>mention<\\box> <box>boxes<\\box>?"


    fun textWidget win txt =
	let val twid = newWidgetId()
	    val (str, ann)= StdMarkup.getAnnotation twid txt
	in  TextWid(twid, NoneScb, str, ann,
		    [Fill X, Side Top], [], [])
	end


    fun quitButton win =
	Button(newWidgetId(),
                   [Side Bottom, Fill X, Expand true],
                   [Relief Ridge, Borderwidth 2,
                    Text "Quit", Command (fn ()=> closeWindow win)], []) 


   fun mainWin txt =
        let val wid = mainWinId();
        in (wid, [WinTitle "SmlTk Standard Markup Test Window"], 
            [textWidget wid txt, quitButton wid],
             fn()=> ())
        end
 
    fun go () = (SmlTk.startTclExn[mainWin sometext];())
                   
end


