(* ***********************************************************************

   Project: sml/Tk: an Tk Toolkit for sml
   Author: Stefan Westmeier, University of Bremen
   Date: $Date: 1997/03/26 16:16:34 $
   Revision: $Revision: 1.4 $
   Purpose of this file: Operations on Widgets Contents

   *********************************************************************** *)

signature WIDGET_OPS =
    sig
	open BasicTypes

	    
	val readTextWidState    : WidId -> bool
	val setTextWidReadOnly  : WidId -> bool -> unit

	val clearTextWidText    : WidId -> unit
	val replaceTextWidText  : WidId -> string -> Annotation list -> unit

	val selectText          : WidId -> Mark * Mark -> string
	val selectTextAll       : WidId                -> string

	val selectSelRange      : WidId -> (Mark * Mark) list 
	val selectSelWindow     : unit  -> (WinId * WidId) SysDep.option
	val selectCursor        : WidId -> BasicTypes.Mark

	val selectVarValue      : string -> string
	val setVarValue         : string -> string        -> unit

    end
